<style>
  .jstree-default > .jstree-striped {
    width: 100%;
  }
  .jstree-node>a {
    /*width: calc(100% - (80px + 1px + 4px));*/
    text-overflow: ellipsis;
    overflow: hidden;
  }
</style>

<h4><%= Admin::PerimeterUser.model_name.human %></h4>

<div class="row">
  <div class="col-md-6">
    <div id="tree_content_ajaxtree" style='padding-top: 5px;'>
      <button class="btn" id="expand_perimeter_tree" type='input'><%= t('.expend')%></button>
      <button class="btn" id="collapse_perimeter_tree"><%= t('.collapse') %></button>

      <div id='tree_zone'>
        <div id="js_tree_perimeter_assign"></div>
      </div>
      <br>
    </div>
  </div>

  <div class="col-md-6">
    <p class='form-group'>
      <label>LISTE DES UTILISATEURS&nbsp;&nbsp;&nbsp;&nbsp;</label>
      <%= form_with url: admin_perimeters_assign_users_path, method: :get, local: true do |form| %>
        <%= select_tag 'attrib_user',
                       options_for_select(@users.collect {|elt| [ elt.full_name, elt.id ]}, @attrib_user.id),
                       class: 'form-control' %>

        <%= form.submit '', id: 'change-user', style: "display: none" %>
      <% end %>
      <br>
    </p>
    <button class="btn btn-outline-warning" id="valid_perimeters_checked"><%= t('.valid') %></button>
  </div>
</div>

<script>
  $(function(){
    // Tree Contents Tree
    mytree = $('#js_tree_perimeter_assign')
    .bind("loaded.jstree", function (e, data) {
        data.instance.open_all();
    })
    .bind("refresh.jstree", function (e, data) {
        data.instance.open_all();
    })
    .jstree({
        "plugins" : [ "themes", "types", "wholerow", "sort", "checkbox"], //, "stackedicon" ],  //
        "themes" : {
            "theme" : "default",
            "icons" : false
        },
        "core": {
            "animation" : 0 ,
            "check_callback" :  function (operation, node_obj, node_parent, node_position, more) {
                                  // Pour empêcher le déplacement de type reorder
                                  if (more && more.dnd && more.pos !== "i") { return false; }
                                  // D&D
                                  if (operation === "move_node") {
                                    return true
                                  }
                                  return true;
                                },
            "themes" : { "stripes" : true },
            "multiple" : false,
            "data" : { "url" : '<%= Rails.application.routes.url_helpers.admin_perimeters_js_tree_data_path(locale: I18n.locale, show_buttons: false, attrib_class: 'User', attrib_id: @attrib_user.id) %>',
                       "data" : function(node) {
                                return { 'id' : node.id };
                            }
                     }
        },
        //"dnd" : { "copy": false, "use_html5" : true, "insid e_pos" : "last" },
        "types" : {
                    "#" : { "icon": "fas fa-universal-access icon_tree_tag" },
                    'perimeter': { "icon": "fas fa-map-marker icon_tree_tag" }
                  },
        // Tri les élems par ID => même ordre que dans la BDD
        "sort" : function (a, b) { return (parseInt(a) < parseInt(b)) ? -1 : 1; },
        // ,
        'checkbox': { //'cascade': 'down+undetermined',
                      // three_state : false, // to avoid that fact that checking a node also check others
                      whole_node : false,  // to avoid checking the box just clicking the node
                      tie_selection : false // for checking without selecting and selecting without checking
                    } // , 'three_state': false }
    })
    // .bind("check_node.jstree", function (e, data) {
    //   console.log("Check " + data.node.id);
    // })
    // .bind("uncheck_node.jstree", function (e, data) {
    //   console.log("Uncheck " + data.node.id);
    // })

    $('#expand_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter_assign").jstree("open_all");
    });
    $('#collapse_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter_assign").jstree("close_all");
    });

    $('#valid_perimeters_checked').on('click', function() {
      let results = $('#js_tree_perimeter_assign').jstree("get_checked", false);
      console.log("CHECKED NODES = ");
      console.log(results);

      let user_id = $('#attrib_user').val();
      console.log('User ID = ');
      console.log(user_id);

      let url = "<%= admin_perimeters_assign_users_valid_url %>";

      let datas = {};
      datas = {'attrib_user': user_id, 'perimeter_ids': results}
      $.ajax({
        url: url,
        type: 'PATCH',
        data: datas,
        dataType: 'script',
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
        success: function(data) {
          console.log('attribution done.');
        }
      });
    });

    $('#attrib_user').change(function(event) {
      $('#change-user').trigger('click');
      console.log('Click change user');
    });

    $('li[data-checkstate="checked"]').each(function() {
      $("#js_tree_perimeter_assign").jstree('check_node', $(this));
    });
  });
</script>
